(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@antv/g')) :
  typeof define === 'function' && define.amd ? define(['exports', '@antv/g'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.G = global.G || {}, global.G.SVG = {}), global.window.G));
}(this, (function (exports, g) { 'use strict';

  function _regeneratorRuntime() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

    _regeneratorRuntime = function () {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function (obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) keys.push(key);

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
      },
      stop: function () {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function (record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf(o, p);
  }

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */

  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
      else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }

  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
  }

  function _regeneratorRuntime$1() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime$1 = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator$1(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _inheritsLoose$1(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf$1(subClass, superClass);
  }

  function _setPrototypeOf$1(o, p) {
    _setPrototypeOf$1 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf$1(o, p);
  }

  var _class;

  var DOMInteractionPlugin_1;
  /**
   * listen to mouse/touch/pointer events on DOM wrapper, trigger pointer events
   */

  var DOMInteractionPlugin = DOMInteractionPlugin_1 = (_class = /*#__PURE__*/function () {
    function DOMInteractionPlugin() {
      this.contextService = void 0;
      this.renderingContext = void 0;
    }

    var _proto = DOMInteractionPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      var canvas = this.renderingContext.root.ownerDocument.defaultView; // const SUPPORT_ONLY_TOUCH = canvas.supportsTouchEvents && MOBILE_REGEX.test(navigator.userAgent);

      var onPointerMove = function onPointerMove(ev) {
        renderingService.hooks.pointerMove.call(ev);
      };

      var onPointerUp = function onPointerUp(ev) {
        renderingService.hooks.pointerUp.call(ev);
      };

      var onPointerDown = function onPointerDown(ev) {
        renderingService.hooks.pointerDown.call(ev);
      };

      var onPointerOver = function onPointerOver(ev) {
        renderingService.hooks.pointerOver.call(ev);
      };

      var onPointerOut = function onPointerOut(ev) {
        renderingService.hooks.pointerOut.call(ev);
      };

      var onPointerCancel = function onPointerCancel(ev) {
        renderingService.hooks.pointerCancel.call(ev);
      };

      var onPointerWheel = function onPointerWheel(ev) {
        renderingService.hooks.pointerWheel.call(ev);
      };

      var addPointerEventListener = function addPointerEventListener($el) {
        globalThis.document.addEventListener('pointermove', onPointerMove, true);
        $el.addEventListener('pointerdown', onPointerDown, true);
        $el.addEventListener('pointerleave', onPointerOut, true);
        $el.addEventListener('pointerover', onPointerOver, true);
        globalThis.addEventListener('pointerup', onPointerUp, true);
      };

      var addTouchEventListener = function addTouchEventListener($el) {
        $el.addEventListener('touchstart', onPointerDown, true);
        $el.addEventListener('touchend', onPointerUp, true);
        $el.addEventListener('touchmove', onPointerMove, true);
        $el.addEventListener('touchcancel', onPointerCancel, true);
      };

      var addMouseEventListener = function addMouseEventListener($el) {
        globalThis.document.addEventListener('mousemove', onPointerMove, true);
        $el.addEventListener('mousedown', onPointerDown, true);
        $el.addEventListener('mouseout', onPointerOut, true);
        $el.addEventListener('mouseover', onPointerOver, true);
        globalThis.addEventListener('mouseup', onPointerUp, true);
      };

      var removePointerEventListener = function removePointerEventListener($el) {
        globalThis.document.removeEventListener('pointermove', onPointerMove, true);
        $el.removeEventListener('pointerdown', onPointerDown, true);
        $el.removeEventListener('pointerleave', onPointerOut, true);
        $el.removeEventListener('pointerover', onPointerOver, true);
        globalThis.removeEventListener('pointerup', onPointerUp, true);
      };

      var removeTouchEventListener = function removeTouchEventListener($el) {
        $el.removeEventListener('touchstart', onPointerDown, true);
        $el.removeEventListener('touchend', onPointerUp, true);
        $el.removeEventListener('touchmove', onPointerMove, true);
        $el.removeEventListener('touchcancel', onPointerCancel, true);
      };

      var removeMouseEventListener = function removeMouseEventListener($el) {
        globalThis.document.removeEventListener('mousemove', onPointerMove, true);
        $el.removeEventListener('mousedown', onPointerDown, true);
        $el.removeEventListener('mouseout', onPointerOut, true);
        $el.removeEventListener('mouseover', onPointerOver, true);
        globalThis.removeEventListener('mouseup', onPointerUp, true);
      };

      renderingService.hooks.init.tapPromise(DOMInteractionPlugin_1.tag, /*#__PURE__*/_asyncToGenerator$1( /*#__PURE__*/_regeneratorRuntime$1().mark(function _callee() {
        var $el;
        return _regeneratorRuntime$1().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                $el = _this.contextService.getDomElement(); // @ts-ignore

                if (globalThis.navigator.msPointerEnabled) {
                  // @ts-ignore
                  $el.style.msContentZooming = 'none'; // @ts-ignore

                  $el.style.msTouchAction = 'none';
                } else if (canvas.supportsPointerEvents) {
                  $el.style.touchAction = 'none';
                }

                if (canvas.supportsPointerEvents) {
                  addPointerEventListener($el);
                } else {
                  addMouseEventListener($el);
                }

                if (canvas.supportsTouchEvents) {
                  addTouchEventListener($el);
                } // use passive event listeners
                // @see https://zhuanlan.zhihu.com/p/24555031


                $el.addEventListener('wheel', onPointerWheel, {
                  passive: true,
                  capture: true
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
      renderingService.hooks.destroy.tap(DOMInteractionPlugin_1.tag, function () {
        var $el = _this.contextService.getDomElement(); // @ts-ignore


        if (globalThis.navigator.msPointerEnabled) {
          // @ts-ignore
          $el.style.msContentZooming = ''; // @ts-ignore

          $el.style.msTouchAction = '';
        } else if (canvas.supportsPointerEvents) {
          $el.style.touchAction = '';
        }

        if (canvas.supportsPointerEvents) {
          removePointerEventListener($el);
        } else {
          removeMouseEventListener($el);
        }

        if (canvas.supportsTouchEvents) {
          removeTouchEventListener($el);
        }

        $el.removeEventListener('wheel', onPointerWheel, true);
      });
    };

    return DOMInteractionPlugin;
  }(), _class.tag = 'DOMInteraction', _class);

  __decorate([g.inject(g.ContextService), __metadata("design:type", Object)], DOMInteractionPlugin.prototype, "contextService", void 0);

  __decorate([g.inject(g.RenderingContext), __metadata("design:type", Object)], DOMInteractionPlugin.prototype, "renderingContext", void 0);

  DOMInteractionPlugin = DOMInteractionPlugin_1 = __decorate([g.singleton({
    contrib: g.RenderingPluginContribution
  })], DOMInteractionPlugin);
  var containerModule = g.Module(function (register) {
    register(DOMInteractionPlugin);
  });

  var Plugin = /*#__PURE__*/function (_AbstractRendererPlug) {
    _inheritsLoose$1(Plugin, _AbstractRendererPlug);

    function Plugin() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _AbstractRendererPlug.call.apply(_AbstractRendererPlug, [this].concat(args)) || this;
      _this.name = 'dom-interaction';
      return _this;
    }

    var _proto = Plugin.prototype;

    _proto.init = function init() {
      this.container.load(containerModule, true);
    };

    _proto.destroy = function destroy() {
      this.container.unload(containerModule);
    };

    return Plugin;
  }(g.AbstractRendererPlugin);

  var index_esm = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Plugin: Plugin
  });

  var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
      if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
          if (ar || !(i in from)) {
              if (!ar) ar = Array.prototype.slice.call(from, 0, i);
              ar[i] = from[i];
          }
      }
      return to.concat(ar || Array.prototype.slice.call(from));
  };
  var BrowserInfo = /** @class */ (function () {
      function BrowserInfo(name, version, os) {
          this.name = name;
          this.version = version;
          this.os = os;
          this.type = 'browser';
      }
      return BrowserInfo;
  }());
  var NodeInfo = /** @class */ (function () {
      function NodeInfo(version) {
          this.version = version;
          this.type = 'node';
          this.name = 'node';
          this.os = process.platform;
      }
      return NodeInfo;
  }());
  var SearchBotDeviceInfo = /** @class */ (function () {
      function SearchBotDeviceInfo(name, version, os, bot) {
          this.name = name;
          this.version = version;
          this.os = os;
          this.bot = bot;
          this.type = 'bot-device';
      }
      return SearchBotDeviceInfo;
  }());
  var BotInfo = /** @class */ (function () {
      function BotInfo() {
          this.type = 'bot';
          this.bot = true; // NOTE: deprecated test name instead
          this.name = 'bot';
          this.version = null;
          this.os = null;
      }
      return BotInfo;
  }());
  var ReactNativeInfo = /** @class */ (function () {
      function ReactNativeInfo() {
          this.type = 'react-native';
          this.name = 'react-native';
          this.version = null;
          this.os = null;
      }
      return ReactNativeInfo;
  }());
  // tslint:disable-next-line:max-line-length
  var SEARCHBOX_UA_REGEX = /alexa|bot|crawl(er|ing)|facebookexternalhit|feedburner|google web preview|nagios|postrank|pingdom|slurp|spider|yahoo!|yandex/;
  var SEARCHBOT_OS_REGEX = /(nuhk|curl|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask\ Jeeves\/Teoma|ia_archiver)/;
  var REQUIRED_VERSION_PARTS = 3;
  var userAgentRules = [
      ['aol', /AOLShield\/([0-9\._]+)/],
      ['edge', /Edge\/([0-9\._]+)/],
      ['edge-ios', /EdgiOS\/([0-9\._]+)/],
      ['yandexbrowser', /YaBrowser\/([0-9\._]+)/],
      ['kakaotalk', /KAKAOTALK\s([0-9\.]+)/],
      ['samsung', /SamsungBrowser\/([0-9\.]+)/],
      ['silk', /\bSilk\/([0-9._-]+)\b/],
      ['miui', /MiuiBrowser\/([0-9\.]+)$/],
      ['beaker', /BeakerBrowser\/([0-9\.]+)/],
      ['edge-chromium', /EdgA?\/([0-9\.]+)/],
      [
          'chromium-webview',
          /(?!Chrom.*OPR)wv\).*Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/,
      ],
      ['chrome', /(?!Chrom.*OPR)Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/],
      ['phantomjs', /PhantomJS\/([0-9\.]+)(:?\s|$)/],
      ['crios', /CriOS\/([0-9\.]+)(:?\s|$)/],
      ['firefox', /Firefox\/([0-9\.]+)(?:\s|$)/],
      ['fxios', /FxiOS\/([0-9\.]+)/],
      ['opera-mini', /Opera Mini.*Version\/([0-9\.]+)/],
      ['opera', /Opera\/([0-9\.]+)(?:\s|$)/],
      ['opera', /OPR\/([0-9\.]+)(:?\s|$)/],
      ['pie', /^Microsoft Pocket Internet Explorer\/(\d+\.\d+)$/],
      ['pie', /^Mozilla\/\d\.\d+\s\(compatible;\s(?:MSP?IE|MSInternet Explorer) (\d+\.\d+);.*Windows CE.*\)$/],
      ['netfront', /^Mozilla\/\d\.\d+.*NetFront\/(\d.\d)/],
      ['ie', /Trident\/7\.0.*rv\:([0-9\.]+).*\).*Gecko$/],
      ['ie', /MSIE\s([0-9\.]+);.*Trident\/[4-7].0/],
      ['ie', /MSIE\s(7\.0)/],
      ['bb10', /BB10;\sTouch.*Version\/([0-9\.]+)/],
      ['android', /Android\s([0-9\.]+)/],
      ['ios', /Version\/([0-9\._]+).*Mobile.*Safari.*/],
      ['safari', /Version\/([0-9\._]+).*Safari/],
      ['facebook', /FB[AS]V\/([0-9\.]+)/],
      ['instagram', /Instagram\s([0-9\.]+)/],
      ['ios-webview', /AppleWebKit\/([0-9\.]+).*Mobile/],
      ['ios-webview', /AppleWebKit\/([0-9\.]+).*Gecko\)$/],
      ['curl', /^curl\/([0-9\.]+)$/],
      ['searchbot', SEARCHBOX_UA_REGEX],
  ];
  var operatingSystemRules = [
      ['iOS', /iP(hone|od|ad)/],
      ['Android OS', /Android/],
      ['BlackBerry OS', /BlackBerry|BB10/],
      ['Windows Mobile', /IEMobile/],
      ['Amazon OS', /Kindle/],
      ['Windows 3.11', /Win16/],
      ['Windows 95', /(Windows 95)|(Win95)|(Windows_95)/],
      ['Windows 98', /(Windows 98)|(Win98)/],
      ['Windows 2000', /(Windows NT 5.0)|(Windows 2000)/],
      ['Windows XP', /(Windows NT 5.1)|(Windows XP)/],
      ['Windows Server 2003', /(Windows NT 5.2)/],
      ['Windows Vista', /(Windows NT 6.0)/],
      ['Windows 7', /(Windows NT 6.1)/],
      ['Windows 8', /(Windows NT 6.2)/],
      ['Windows 8.1', /(Windows NT 6.3)/],
      ['Windows 10', /(Windows NT 10.0)/],
      ['Windows ME', /Windows ME/],
      ['Windows CE', /Windows CE|WinCE|Microsoft Pocket Internet Explorer/],
      ['Open BSD', /OpenBSD/],
      ['Sun OS', /SunOS/],
      ['Chrome OS', /CrOS/],
      ['Linux', /(Linux)|(X11)/],
      ['Mac OS', /(Mac_PowerPC)|(Macintosh)/],
      ['QNX', /QNX/],
      ['BeOS', /BeOS/],
      ['OS/2', /OS\/2/],
  ];
  function detect(userAgent) {
      if (!!userAgent) {
          return parseUserAgent(userAgent);
      }
      if (typeof document === 'undefined' &&
          typeof navigator !== 'undefined' &&
          navigator.product === 'ReactNative') {
          return new ReactNativeInfo();
      }
      if (typeof navigator !== 'undefined') {
          return parseUserAgent(navigator.userAgent);
      }
      return getNodeVersion();
  }
  function matchUserAgent(ua) {
      // opted for using reduce here rather than Array#first with a regex.test call
      // this is primarily because using the reduce we only perform the regex
      // execution once rather than once for the test and for the exec again below
      // probably something that needs to be benchmarked though
      return (ua !== '' &&
          userAgentRules.reduce(function (matched, _a) {
              var browser = _a[0], regex = _a[1];
              if (matched) {
                  return matched;
              }
              var uaMatch = regex.exec(ua);
              return !!uaMatch && [browser, uaMatch];
          }, false));
  }
  function parseUserAgent(ua) {
      var matchedRule = matchUserAgent(ua);
      if (!matchedRule) {
          return null;
      }
      var name = matchedRule[0], match = matchedRule[1];
      if (name === 'searchbot') {
          return new BotInfo();
      }
      // Do not use RegExp for split operation as some browser do not support it (See: http://blog.stevenlevithan.com/archives/cross-browser-split)
      var versionParts = match[1] && match[1].split('.').join('_').split('_').slice(0, 3);
      if (versionParts) {
          if (versionParts.length < REQUIRED_VERSION_PARTS) {
              versionParts = __spreadArray(__spreadArray([], versionParts, true), createVersionParts(REQUIRED_VERSION_PARTS - versionParts.length), true);
          }
      }
      else {
          versionParts = [];
      }
      var version = versionParts.join('.');
      var os = detectOS(ua);
      var searchBotMatch = SEARCHBOT_OS_REGEX.exec(ua);
      if (searchBotMatch && searchBotMatch[1]) {
          return new SearchBotDeviceInfo(name, version, os, searchBotMatch[1]);
      }
      return new BrowserInfo(name, version, os);
  }
  function detectOS(ua) {
      for (var ii = 0, count = operatingSystemRules.length; ii < count; ii++) {
          var _a = operatingSystemRules[ii], os = _a[0], regex = _a[1];
          var match = regex.exec(ua);
          if (match) {
              return os;
          }
      }
      return null;
  }
  function getNodeVersion() {
      var isNode = typeof process !== 'undefined' && process.version;
      return isNode ? new NodeInfo(process.version.slice(1)) : null;
  }
  function createVersionParts(count) {
      var output = [];
      for (var ii = 0; ii < count; ii++) {
          output.push('0');
      }
      return output;
  }

  function _regeneratorRuntime$2() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime$2 = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator$2(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep$2(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };
    return _extends.apply(this, arguments);
  }

  function _inheritsLoose$2(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf$2(subClass, superClass);
  }

  function _setPrototypeOf$2(o, p) {
    _setPrototypeOf$2 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf$2(o, p);
  }

  var ElementSVG = function ElementSVG() {
    this.$el = void 0;
    this.$groupEl = void 0;
    this.$hitTestingEl = void 0;
  };

  ElementSVG.tag = 'c-svg-element';

  function updateImageElementAttribute($el, parsedStyle) {
    var _parsedStyle$img = parsedStyle.img,
        img = _parsedStyle$img === void 0 ? '' : _parsedStyle$img,
        width = parsedStyle.width,
        height = parsedStyle.height;
    $el.setAttribute('x', '0');
    $el.setAttribute('y', '0');

    if (g.isString(img)) {
      $el.setAttribute('href', img);
    } else if (img instanceof Image) {
      if (!width) {
        $el.setAttribute('width', "" + img.width); // TODO: set renderable.boundsDirty
        // this.attr('width', img.width);
      }

      if (!height) {
        $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
      }

      $el.setAttribute('href', img.src);
    } else if ( // @ts-ignore
    img instanceof HTMLElement && g.isString(img.nodeName) && img.nodeName.toUpperCase() === 'CANVAS') {
      $el.setAttribute('href', img.toDataURL()); // @ts-ignore
    } else if (img instanceof ImageData) {
      var canvas = document.createElement('canvas'); // @ts-ignore

      canvas.setAttribute('width', "" + img.width); // @ts-ignore

      canvas.setAttribute('height', "" + img.height);
      var context = canvas.getContext('2d');

      if (context) {
        context.putImageData(img, 0, 0);

        if (!width) {
          // @ts-ignore
          $el.setAttribute('width', "" + img.width); // this.attr('width', img.width);
        }

        if (!height) {
          // @ts-ignore
          $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
        }

        $el.setAttribute('href', canvas.toDataURL());
      }
    }
  }

  function updateLineElementAttribute($el, parsedStyle) {
    var x1 = parsedStyle.x1,
        y1 = parsedStyle.y1,
        x2 = parsedStyle.x2,
        y2 = parsedStyle.y2,
        _parsedStyle$defX = parsedStyle.defX,
        defX = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
        _parsedStyle$defY = parsedStyle.defY,
        defY = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY,
        markerStart = parsedStyle.markerStart,
        markerEnd = parsedStyle.markerEnd,
        markerStartOffset = parsedStyle.markerStartOffset,
        markerEndOffset = parsedStyle.markerEndOffset;
    var startOffsetX = 0;
    var startOffsetY = 0;
    var endOffsetX = 0;
    var endOffsetY = 0;
    var rad = 0;
    var x;
    var y;

    if (markerStart && markerStart instanceof g.DisplayObject && markerStartOffset) {
      x = x2 - x1;
      y = y2 - y1;
      rad = Math.atan2(y, x);
      startOffsetX = Math.cos(rad) * (markerStartOffset || 0);
      startOffsetY = Math.sin(rad) * (markerStartOffset || 0);
    }

    if (markerEnd && markerEnd instanceof g.DisplayObject && markerEndOffset) {
      x = x1 - x2;
      y = y1 - y2;
      rad = Math.atan2(y, x);
      endOffsetX = Math.cos(rad) * (markerEndOffset || 0);
      endOffsetY = Math.sin(rad) * (markerEndOffset || 0);
    } // @see https://github.com/antvis/g/issues/1038


    $el.setAttribute('x1', "" + (x1 - defX + startOffsetX));
    $el.setAttribute('y1', "" + (y1 - defY + startOffsetY));
    $el.setAttribute('x2', "" + (x2 - defX + endOffsetX));
    $el.setAttribute('y2', "" + (y2 - defY + endOffsetY));
  }

  function updatePathElementAttribute($el, parsedStyle) {
    var path = parsedStyle.path,
        _parsedStyle$defX = parsedStyle.defX,
        defX = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
        _parsedStyle$defY = parsedStyle.defY,
        defY = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY,
        markerStart = parsedStyle.markerStart,
        markerEnd = parsedStyle.markerEnd,
        markerStartOffset = parsedStyle.markerStartOffset,
        markerEndOffset = parsedStyle.markerEndOffset;
    var startOffsetX = 0;
    var startOffsetY = 0;
    var endOffsetX = 0;
    var endOffsetY = 0;
    var rad = 0;
    var x;
    var y;

    if (markerStart && markerStart instanceof g.DisplayObject && markerStartOffset) {
      var _markerStart$parentNo = markerStart.parentNode.getStartTangent(),
          p1 = _markerStart$parentNo[0],
          p2 = _markerStart$parentNo[1];

      x = p1[0] - p2[0];
      y = p1[1] - p2[1];
      rad = Math.atan2(y, x);
      startOffsetX = Math.cos(rad) * (markerStartOffset || 0);
      startOffsetY = Math.sin(rad) * (markerStartOffset || 0);
    }

    if (markerEnd && markerEnd instanceof g.DisplayObject && markerEndOffset) {
      var _markerEnd$parentNode = markerEnd.parentNode.getEndTangent(),
          _p = _markerEnd$parentNode[0],
          _p2 = _markerEnd$parentNode[1];

      x = _p[0] - _p2[0];
      y = _p[1] - _p2[1];
      rad = Math.atan2(y, x);
      endOffsetX = Math.cos(rad) * (markerEndOffset || 0);
      endOffsetY = Math.sin(rad) * (markerEndOffset || 0);
    }

    $el.setAttribute('d', g.translatePathToString(path.absolutePath, defX, defY, startOffsetX, startOffsetY, endOffsetX, endOffsetY));
  }

  function updatePolylineElementAttribute($el, parsedStyle) {
    var points = parsedStyle.points.points,
        _parsedStyle$defX = parsedStyle.defX,
        defX = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
        _parsedStyle$defY = parsedStyle.defY,
        defY = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY,
        markerStart = parsedStyle.markerStart,
        markerStartOffset = parsedStyle.markerStartOffset,
        markerEnd = parsedStyle.markerEnd,
        markerEndOffset = parsedStyle.markerEndOffset;
    var length = points.length;

    if (points && length >= 2) {
      var startOffsetX = 0;
      var startOffsetY = 0;
      var endOffsetX = 0;
      var endOffsetY = 0;
      var rad = 0;
      var x;
      var y;

      if (markerStart && markerStart instanceof g.DisplayObject && markerStartOffset) {
        x = points[1][0] - points[0][0];
        y = points[1][1] - points[0][1];
        rad = Math.atan2(y, x);
        startOffsetX = Math.cos(rad) * (markerStartOffset || 0);
        startOffsetY = Math.sin(rad) * (markerStartOffset || 0);
      }

      if (markerEnd && markerEnd instanceof g.DisplayObject && markerEndOffset) {
        x = points[length - 2][0] - points[length - 1][0];
        y = points[length - 2][1] - points[length - 1][1];
        rad = Math.atan2(y, x);
        endOffsetX = Math.cos(rad) * (markerEndOffset || 0);
        endOffsetY = Math.sin(rad) * (markerEndOffset || 0);
      }

      $el.setAttribute('points', points.map(function (point, i) {
        var offsetX = 0;
        var offsetY = 0;

        if (i === 0) {
          offsetX = startOffsetX;
          offsetY = startOffsetY;
        } else if (i === length - 1) {
          offsetX = endOffsetX;
          offsetY = endOffsetY;
        }

        return point[0] - defX + offsetX + "," + (point[1] - defY + offsetY);
      }).join(' '));
    }
  }

  function updateRectElementAttribute($el, parsedStyle) {
    var radius = parsedStyle.radius,
        width = parsedStyle.width,
        height = parsedStyle.height; // CSSKeyword: auto

    if (!isFinite(width) || !isFinite(height)) {
      return;
    }

    var hasRadius = radius && radius.some(function (r) {
      return r !== 0;
    });
    var d = '';

    if (!hasRadius) {
      d = "M 0,0 l " + width + ",0 l 0," + height + " l" + -width + " 0 z";
    } else {
      var _radius$map = radius.map(function (r) {
        return g.clamp(r, 0, Math.min(Math.abs(width) / 2, Math.abs(height) / 2));
      }),
          tlr = _radius$map[0],
          trr = _radius$map[1],
          brr = _radius$map[2],
          blr = _radius$map[3];

      var signX = width > 0 ? 1 : -1;
      var signY = height > 0 ? 1 : -1; // sweep-flag @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Tutorial/Paths#arcs

      var sweepFlag = signX + signY !== 0 ? 1 : 0;
      d = [["M " + signX * tlr + ",0"], ["l " + (width - signX * (tlr + trr)) + ",0"], ["a " + trr + "," + trr + ",0,0," + sweepFlag + "," + signX * trr + "," + signY * trr], ["l 0," + (height - signY * (trr + brr))], ["a " + brr + "," + brr + ",0,0," + sweepFlag + "," + -signX * brr + "," + signY * brr], ["l " + (signX * (brr + blr) - width) + ",0"], ["a " + blr + "," + blr + ",0,0," + sweepFlag + "," + -signX * blr + "," + -signY * blr], ["l 0," + (signY * (blr + tlr) - height)], ["a " + tlr + "," + tlr + ",0,0," + sweepFlag + "," + signX * tlr + "," + -signY * tlr], ['z']].join(' ');
    }

    $el.setAttribute('d', d);
  }

  function numberToLongString(x) {
    return x.toFixed(6).replace('.000000', '');
  }

  function convertHTML(str) {
    var regex = /[&|<|>|"|']/g;
    return str.replace(regex, function (match) {
      if (match === '&') {
        return '&amp;';
      } else if (match === '<') {
        return '&lt;';
      } else if (match === '>') {
        return '&gt;';
      } else if (match === '"') {
        return '&quot;';
      } else {
        return '&apos;';
      }
    });
  }

  var BASELINE_MAP = {
    top: 'before-edge',
    middle: 'central',
    bottom: 'after-edge',
    alphabetic: 'alphabetic',
    ideographic: 'ideographic',
    hanging: 'hanging'
  }; // for FireFox
  // @see https://github.com/plouc/nivo/issues/164

  var BASELINE_MAP_FOR_FIREFOX = {
    top: 'text-before-edge',
    middle: 'central',
    bottom: 'text-after-edge',
    alphabetic: 'alphabetic',
    ideographic: 'ideographic',
    hanging: 'hanging'
  };

  function updateTextElementAttribute($el, parsedStyle) {
    var textBaseline = parsedStyle.textBaseline,
        lineWidth = parsedStyle.lineWidth,
        metrics = parsedStyle.metrics,
        dx = parsedStyle.dx,
        dy = parsedStyle.dy;
    var browser = detect();

    if (browser && browser.name === 'firefox') {
      // compatible with FireFox browser, ref: https://github.com/antvis/g/issues/119
      $el.setAttribute('dominant-baseline', BASELINE_MAP_FOR_FIREFOX[textBaseline] || 'alphabetic');
    } else {
      $el.setAttribute('dominant-baseline', BASELINE_MAP_FOR_FIREFOX[textBaseline]);
      $el.setAttribute('alignment-baseline', BASELINE_MAP[textBaseline]);
    }

    $el.setAttribute('paint-order', 'stroke');
    var lines = metrics.lines,
        lineHeight = metrics.lineHeight,
        height = metrics.height;
    var lineNum = lines.length;
    $el.setAttribute('style', "transform:translate(" + dx + "px, " + dy + "px);");

    if (lineNum === 1) {
      $el.innerHTML = convertHTML(lines[0]);
      $el.setAttribute('dx', "" + lineWidth / 2);
    } else {
      $el.innerHTML = lines.map(function (line, i) {
        var dx = lineWidth / 2;
        var dy = 0;

        if (i === 0) {
          // TODO: handle other textBaseline values
          if (textBaseline === 'middle') {
            dy = lineHeight / 2 - height / 2;
          } else if (textBaseline === 'top' || textBaseline === 'hanging') {
            dy = 0;
          } else if (textBaseline === 'bottom' || textBaseline === 'alphabetic' || textBaseline === 'ideographic') {
            dy = -lineHeight * (lineNum - 1);
          }
        } else {
          dy = lineHeight;
        }

        return "<tspan x=\"0\" dx=\"" + dx + "\" dy=\"" + dy + "\">" + convertHTML(line) + "</tspan>";
      }).join('');
    }
  }

  var ElementLifeCycleContribution = g.Syringe.defineToken('', {
    multiple: false
  });

  function createSVGElement(type, doc) {
    return (doc || document).createElementNS('http://www.w3.org/2000/svg', type);
  }

  var _SHAPE2TAGS, _SHAPE_UPDATE_DEPS;

  var SHAPE2TAGS = (_SHAPE2TAGS = {}, _SHAPE2TAGS[g.Shape.RECT] = 'path', _SHAPE2TAGS[g.Shape.CIRCLE] = 'circle', _SHAPE2TAGS[g.Shape.ELLIPSE] = 'ellipse', _SHAPE2TAGS[g.Shape.IMAGE] = 'image', _SHAPE2TAGS[g.Shape.GROUP] = 'g', _SHAPE2TAGS[g.Shape.LINE] = 'line', _SHAPE2TAGS[g.Shape.POLYLINE] = 'polyline', _SHAPE2TAGS[g.Shape.POLYGON] = 'polygon', _SHAPE2TAGS[g.Shape.TEXT] = 'text', _SHAPE2TAGS[g.Shape.PATH] = 'path', _SHAPE2TAGS[g.Shape.HTML] = 'foreignObject', _SHAPE2TAGS);
  var SHAPE_UPDATE_DEPS = (_SHAPE_UPDATE_DEPS = {}, _SHAPE_UPDATE_DEPS[g.Shape.CIRCLE] = ['r'], _SHAPE_UPDATE_DEPS[g.Shape.ELLIPSE] = ['rx', 'ry'], _SHAPE_UPDATE_DEPS[g.Shape.RECT] = ['width', 'height', 'radius'], _SHAPE_UPDATE_DEPS[g.Shape.IMAGE] = ['img', 'width', 'height'], _SHAPE_UPDATE_DEPS[g.Shape.LINE] = ['x1', 'y1', 'x2', 'y2', 'markerStart', 'markerEnd', 'markerStartOffset', 'markerEndOffset'], _SHAPE_UPDATE_DEPS[g.Shape.POLYLINE] = ['points', 'markerStart', 'markerEnd', 'markerMid', 'markerStartOffset', 'markerEndOffset'], _SHAPE_UPDATE_DEPS[g.Shape.POLYGON] = ['points', 'markerStart', 'markerEnd', 'markerMid', 'markerStartOffset', 'markerEndOffset'], _SHAPE_UPDATE_DEPS[g.Shape.PATH] = ['path', 'markerStart', 'markerEnd', 'markerMid', 'markerStartOffset', 'markerEndOffset'], _SHAPE_UPDATE_DEPS[g.Shape.TEXT] = ['text', 'font', 'fontSize', 'fontFamily', 'fontStyle', 'fontWeight', 'fontVariant', 'lineHeight', 'letterSpacing', 'wordWrap', 'wordWrapWidth', 'leading', 'textBaseline', 'textAlign', 'textTransform', 'whiteSpace', 'dx', 'dy'], _SHAPE_UPDATE_DEPS);

  var DefaultElementLifeCycleContribution = /*#__PURE__*/function () {
    function DefaultElementLifeCycleContribution() {
      this.canvasConfig = void 0;
    }

    var _proto = DefaultElementLifeCycleContribution.prototype;

    _proto.createElement = function createElement(object) {
      var doc = this.canvasConfig.document;
      var type = SHAPE2TAGS[object.nodeName] || 'g';
      return createSVGElement(type, doc || document);
    };

    _proto.destroyElement = function destroyElement(object, $el) {};

    _proto.shouldUpdateElementAttribute = function shouldUpdateElementAttribute(object, attributeName) {
      var nodeName = object.nodeName;
      return (SHAPE_UPDATE_DEPS[nodeName] || []).indexOf(attributeName) > -1;
    };

    _proto.updateElementAttribute = function updateElementAttribute(object) {
      // @ts-ignore
      var $el = object.elementSVG.$el;
      var nodeName = object.nodeName,
          parsedStyle = object.parsedStyle;

      switch (nodeName) {
        case g.Shape.IMAGE:
          {
            updateImageElementAttribute($el, parsedStyle);
            break;
          }

        case g.Shape.RECT:
          {
            updateRectElementAttribute($el, parsedStyle);
            break;
          }

        case g.Shape.LINE:
          {
            updateLineElementAttribute($el, parsedStyle);
            break;
          }

        case g.Shape.POLYGON:
        case g.Shape.POLYLINE:
          {
            updatePolylineElementAttribute($el, parsedStyle);
            break;
          }

        case g.Shape.PATH:
          {
            updatePathElementAttribute($el, parsedStyle);
            break;
          }

        case g.Shape.TEXT:
          {
            updateTextElementAttribute($el, parsedStyle);
            break;
          }
      }
    };

    return DefaultElementLifeCycleContribution;
  }();

  __decorate([g.inject(g.CanvasConfig), __metadata("design:type", Object)], DefaultElementLifeCycleContribution.prototype, "canvasConfig", void 0);

  DefaultElementLifeCycleContribution = __decorate([g.singleton({
    token: ElementLifeCycleContribution
  })], DefaultElementLifeCycleContribution);
  var FILTER_PREFIX = 'g-filter-';
  /**
   * use SVG filters, eg. blur, brightness, contrast...
   * @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/filter
   */

  function createOrUpdateFilter(document, $def, object, $el, filters) {
    // eg. filter="url(#f1) url(#f2)"
    var filterName = FILTER_PREFIX + object.entity;
    var $existedFilters = $def.querySelectorAll("[name=" + filterName + "]");

    if ($existedFilters.length) {
      $existedFilters.forEach(function ($filter) {
        $def.removeChild($filter);
      });
    }

    if (filters.length === 0) {
      // 'none'
      $el === null || $el === void 0 ? void 0 : $el.removeAttribute('filter');
    } else {
      var filterIds = filters.map(function (_ref, i) {
        var name = _ref.name,
            params = _ref.params;
        var $filter = createSVGElement('filter', document); // @see https://github.com/antvis/g/issues/1025

        $filter.setAttribute('filterUnits', 'userSpaceOnUse');

        if (name === 'blur') {
          createBlur(document, $filter, params);
        } else if (name === 'brightness') {
          createBrightness(document, $filter, params);
        } else if (name === 'drop-shadow') {
          createDropShadow(document, $filter, params);
        } else if (name === 'contrast') {
          createContrast(document, $filter, params);
        } else if (name === 'grayscale') {
          createGrayscale(document, $filter, params);
        } else if (name === 'sepia') {
          createSepia(document, $filter, params);
        } else if (name === 'saturate') {
          createSaturate(document, $filter, params);
        } else if (name === 'hue-rotate') {
          createHueRotate(document, $filter, params);
        } else if (name === 'invert') {
          createInvert(document, $filter, params);
        }

        $filter.id = filterName + "-" + i;
        $filter.setAttribute('name', filterName);
        $def.appendChild($filter);
        return $filter.id;
      }); // @see https://github.com/antvis/G/issues/1114

      setTimeout(function () {
        $el === null || $el === void 0 ? void 0 : $el.setAttribute('filter', filterIds.map(function (filterId) {
          return "url(#" + filterId + ")";
        }).join(' '));
      });
    }
  }

  function convertToAbsoluteValue(param) {
    return param.unit === g.UnitType.kPercentage ? param.value / 100 : param.value;
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#blurEquivalent
   */


  function createBlur(document, $filter, params) {
    var $feGaussianBlur = createSVGElement('feGaussianBlur', document);
    $feGaussianBlur.setAttribute('in', 'SourceGraphic');
    $feGaussianBlur.setAttribute('stdDeviation', "" + params[0].value);
    $filter.appendChild($feGaussianBlur);
  }

  function createFeComponentTransfer(document, $filter, _ref2) {
    var type = _ref2.type,
        slope = _ref2.slope,
        intercept = _ref2.intercept,
        tableValues = _ref2.tableValues;
    var $feComponentTransfer = createSVGElement('feComponentTransfer', document);
    [createSVGElement('feFuncR', document), createSVGElement('feFuncG', document), createSVGElement('feFuncB', document)].forEach(function ($feFunc) {
      $feFunc.setAttribute('type', type);

      if (type === 'table') {
        $feFunc.setAttribute('tableValues', "" + tableValues);
      } else {
        $feFunc.setAttribute('slope', "" + slope);
        $feFunc.setAttribute('intercept', "" + intercept);
      }

      $feComponentTransfer.appendChild($feFunc);
    });
    $filter.appendChild($feComponentTransfer);
  }

  function createContrast(document, $filter, params) {
    var slope = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer(document, $filter, {
      type: 'linear',
      slope: slope,
      intercept: -(0.5 * slope) + 0.5
    });
  }

  function createInvert(document, $filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer(document, $filter, {
      type: 'table',
      tableValues: amount + " " + (1 - amount)
    });
  }

  function createBrightness(document, $filter, params) {
    var slope = convertToAbsoluteValue(params[0]);
    createFeComponentTransfer(document, $filter, {
      type: 'linear',
      slope: slope,
      intercept: 0
    });
  }

  function createSaturate(document, $filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    var $feColorMatrix = createSVGElement('feColorMatrix', document);
    $feColorMatrix.setAttribute('type', 'saturate');
    $feColorMatrix.setAttribute('values', "" + amount);
    $filter.appendChild($feColorMatrix);
  }

  function createHueRotate(document, $filter, params) {
    var $feColorMatrix = createSVGElement('feColorMatrix', document);
    $feColorMatrix.setAttribute('type', 'hueRotate');
    $feColorMatrix.setAttribute('values', "" + params[0].to(g.UnitType.kDegrees).value);
    $filter.appendChild($feColorMatrix);
  }

  function createDropShadow(document, $filter, params) {
    var shadowOffsetX = params[0].value;
    var shadowOffsetY = params[1].value;
    var shadowBlur = params[2].value; // @ts-ignore

    var shadowColor = params[3].formatted;
    var $feGaussianBlur = createSVGElement('feGaussianBlur', document);
    $feGaussianBlur.setAttribute('in', 'SourceAlpha');
    $feGaussianBlur.setAttribute('stdDeviation', "" + shadowBlur);
    $filter.appendChild($feGaussianBlur);
    var $feOffset = createSVGElement('feOffset', document);
    $feOffset.setAttribute('dx', "" + shadowOffsetX);
    $feOffset.setAttribute('dy', "" + shadowOffsetY);
    $feOffset.setAttribute('result', 'offsetblur');
    $filter.appendChild($feOffset);
    var $feFlood = createSVGElement('feFlood', document);
    $feFlood.setAttribute('flood-color', shadowColor);
    $filter.appendChild($feFlood);
    var $feComposite = createSVGElement('feComposite', document);
    $feComposite.setAttribute('in2', 'offsetblur');
    $feComposite.setAttribute('operator', 'in');
    $filter.appendChild($feComposite);
    var $feMerge = createSVGElement('feMerge', document);
    $filter.appendChild($feMerge);
    var $feMergeNode1 = createSVGElement('feMergeNode', document);
    var $feMergeNode2 = createSVGElement('feMergeNode', document);
    $feMergeNode2.setAttribute('in', 'SourceGraphic');
    $feMerge.appendChild($feMergeNode1);
    $feMerge.appendChild($feMergeNode2);
  }

  function createFeColorMatrix(document, $filter, matrix) {
    var $feColorMatrix = createSVGElement('feColorMatrix', document);
    $feColorMatrix.setAttribute('type', 'matrix');
    $feColorMatrix.setAttribute('values', matrix.join(' '));
    $filter.appendChild($feColorMatrix);
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#grayscaleEquivalent
   */


  function createGrayscale(document, $filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeColorMatrix(document, $filter, [0.2126 + 0.7874 * (1 - amount), 0.7152 - 0.7152 * (1 - amount), 0.0722 - 0.0722 * (1 - amount), 0, 0, 0.2126 - 0.2126 * (1 - amount), 0.7152 + 0.2848 * (1 - amount), 0.0722 - 0.0722 * (1 - amount), 0, 0, 0.2126 - 0.2126 * (1 - amount), 0.7152 - 0.7152 * (1 - amount), 0.0722 + 0.9278 * (1 - amount), 0, 0, 0, 0, 0, 1, 0]);
  }
  /**
   * @see https://drafts.fxtf.org/filter-effects/#sepiaEquivalent
   */


  function createSepia(document, $filter, params) {
    var amount = convertToAbsoluteValue(params[0]);
    createFeColorMatrix(document, $filter, [0.393 + 0.607 * (1 - amount), 0.769 - 0.769 * (1 - amount), 0.189 - 0.189 * (1 - amount), 0, 0, 0.349 - 0.349 * (1 - amount), 0.686 + 0.314 * (1 - amount), 0.168 - 0.168 * (1 - amount), 0, 0, 0.272 - 0.272 * (1 - amount), 0.534 - 0.534 * (1 - amount), 0.131 + 0.869 * (1 - amount), 0, 0, 0, 0, 0, 1, 0]);
  }

  var PATTERN_PREFIX = 'g-pattern-';
  var cacheKey2IDMap = {};
  var counter = 0;

  function createOrUpdateGradientAndPattern(document, $def, object, $el, parsedColor, name, createImage) {
    // eg. clipPath don't have fill/stroke
    if (!parsedColor) {
      return '';
    }

    if (parsedColor instanceof g.CSSRGB) {
      // keep using currentColor @see https://github.com/d3/d3-axis/issues/49
      if (object.style[name] === 'currentColor') {
        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, 'currentColor');
      } else {
        // constant value, eg. '#fff'
        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, parsedColor.isNone ? 'none' : parsedColor.toString());
      }
    } else if (g.isPattern(parsedColor)) {
      var patternId = createOrUpdatePattern(document, $def, object, parsedColor, createImage); // use style instead of attribute when applying <pattern>
      // @see https://stackoverflow.com/a/7723115

      $el.style[name] = "url(#" + patternId + ")";
      return patternId;
    } else {
      if (parsedColor.length === 1) {
        var gradientId = createOrUpdateGradient(document, object, $def, $el, parsedColor[0]);
        $el === null || $el === void 0 ? void 0 : $el.setAttribute(name, "url(#" + gradientId + ")");
        return gradientId;
      } else {
        // @see https://stackoverflow.com/questions/20671502/can-i-blend-gradients-in-svg
        var filterId = createOrUpdateMultiGradient(document, object, $def, $el, parsedColor);
        $el === null || $el === void 0 ? void 0 : $el.setAttribute('filter', "url(#" + filterId + ")");
        $el === null || $el === void 0 ? void 0 : $el.setAttribute('fill', 'black');
        return filterId;
      }
    }

    return '';
  }

  function generateCacheKey(src, options) {
    if (options === void 0) {
      options = {};
    }

    var cacheKey = '';

    if (src instanceof g.CSSGradientValue) {
      var type = src.type,
          value = src.value;

      if (type === g.GradientType.LinearGradient || type === g.GradientType.RadialGradient) {
        // @ts-ignore
        var _value$options = _extends({}, value, options),
            _type = _value$options.type,
            width = _value$options.width,
            height = _value$options.height,
            steps = _value$options.steps,
            angle = _value$options.angle,
            cx = _value$options.cx,
            cy = _value$options.cy;

        cacheKey = "" + _type + width + height + (angle || 0) + (cx || 0) + (cy || 0) + steps.map(function (step) {
          return step.join('');
        }).join('');
      }
    } else if (g.isPattern(src)) {
      if (g.isString(src.image)) {
        cacheKey = "pattern-" + src.image + "-" + src.repetition;
      } else {
        cacheKey = "pattern-" + counter;
      }
    }

    if (cacheKey) {
      if (!cacheKey2IDMap[cacheKey]) {
        cacheKey2IDMap[cacheKey] = PATTERN_PREFIX + ("" + counter++);
      }
    }

    return cacheKey2IDMap[cacheKey];
  }

  function createOrUpdatePattern(document, $def, object, pattern, createImage) {
    var patternId = generateCacheKey(pattern);
    var $existed = $def.querySelector("#" + patternId);

    if (!$existed) {
      var image = pattern.image,
          repetition = pattern.repetition;
      var imageURL = '';

      if (g.isString(image)) {
        imageURL = image;
      } else {
        if (g.isBrowser) {
          if (image instanceof HTMLImageElement) {
            imageURL = image.src;
          } else if (image instanceof HTMLCanvasElement) {
            imageURL = image.toDataURL();
          } else ;
        }
      }

      if (imageURL) {
        // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/pattern
        var $pattern = createSVGElement('pattern', document);
        $pattern.setAttribute('patternUnits', 'userSpaceOnUse');
        var $image = createSVGElement('image', document);
        $pattern.appendChild($image);
        $pattern.id = patternId;
        $def.appendChild($pattern); // use href instead of xlink:href
        // @see https://stackoverflow.com/a/13379007

        $image.setAttribute('href', imageURL);
        var img;

        if (createImage) {
          img = createImage(imageURL);
        } else if (g.isBrowser) {
          img = new window.Image();
        }

        if (!imageURL.match(/^data:/i)) {
          img.crossOrigin = 'Anonymous';
          $image.setAttribute('crossorigin', 'anonymous');
        }

        img.src = imageURL;

        var onload = function onload() {
          $pattern.setAttribute('x', '0');
          $pattern.setAttribute('y', '0');

          var _object$getGeometryBo = object.getGeometryBounds(),
              halfExtents = _object$getGeometryBo.halfExtents; // There is no equivalent to CSS no-repeat for SVG patterns
          // @see https://stackoverflow.com/a/33481956


          var patternWidth = img.width;
          var patternHeight = img.height;

          if (repetition === 'repeat-x') {
            patternHeight = halfExtents[1] * 2;
          } else if (repetition === 'repeat-y') {
            patternWidth = halfExtents[0] * 2;
          } else if (repetition === 'no-repeat') {
            patternWidth = halfExtents[0] * 2;
            patternHeight = halfExtents[1] * 2;
          }

          $pattern.setAttribute('width', "" + patternWidth);
          $pattern.setAttribute('height', "" + patternHeight);
          $image.setAttribute('x', '0');
          $image.setAttribute('y', '0');
          $image.setAttribute('width', "" + img.width);
          $image.setAttribute('height', "" + img.height);
        };

        if (img.complete) {
          onload();
        } else {
          img.onload = onload; // Fix onload() bug in IE9

          img.src = img.src;
        }
      }
    }

    return patternId;
  }

  function createOrUpdateGradient(document, object, $def, $el, parsedColor) {
    var bounds = object.getGeometryBounds();
    var width = bounds && bounds.halfExtents[0] * 2 || 0;
    var height = bounds && bounds.halfExtents[1] * 2 || 0;
    var gradientId = generateCacheKey(parsedColor, {
      width: width,
      height: height
    });
    var $existed = $def.querySelector("#" + gradientId);

    if (!$existed) {
      // <linearGradient> <radialGradient>
      // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/linearGradient
      // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/radialGradient
      $existed = createSVGElement(parsedColor.type === g.GradientType.LinearGradient ? 'linearGradient' : 'radialGradient', document); // @see https://github.com/antvis/g/issues/1025

      $existed.setAttribute('gradientUnits', 'userSpaceOnUse'); // add stops

      var innerHTML = '';
      parsedColor.value.steps.forEach(function (_ref) {
        var offset = _ref[0],
            color = _ref[1];
        innerHTML += "<stop offset=\"" + offset + "\" stop-color=\"" + color + "\"></stop>";
      });
      $existed.innerHTML = innerHTML;
      $existed.id = gradientId;
      $def.appendChild($existed);
    }

    if (parsedColor.type === g.GradientType.LinearGradient) {
      var angle = parsedColor.value.angle;

      var _computeLinearGradien = g.computeLinearGradient(width, height, angle),
          x1 = _computeLinearGradien.x1,
          y1 = _computeLinearGradien.y1,
          x2 = _computeLinearGradien.x2,
          y2 = _computeLinearGradien.y2;

      $existed.setAttribute('x1', "" + x1);
      $existed.setAttribute('y1', "" + y1);
      $existed.setAttribute('x2', "" + x2);
      $existed.setAttribute('y2', "" + y2); // $existed.setAttribute('gradientTransform', `rotate(${angle})`);
    } else {
      var _parsedColor$value = parsedColor.value,
          cx = _parsedColor$value.cx,
          cy = _parsedColor$value.cy;

      var _computeRadialGradien = g.computeRadialGradient(width, height, cx, cy),
          x = _computeRadialGradien.x,
          y = _computeRadialGradien.y,
          r = _computeRadialGradien.r;

      $existed.setAttribute('cx', "" + x);
      $existed.setAttribute('cy', "" + y);
      $existed.setAttribute('r', "" + r);
    }

    return gradientId;
  }

  function createOrUpdateMultiGradient(document, object, $def, $el, gradients) {
    var filterId = FILTER_PREFIX + object.entity + '-gradient';
    var $existed = $def.querySelector("#" + filterId);

    if (!$existed) {
      $existed = createSVGElement('filter', document);
      $existed.setAttribute('filterUnits', 'userSpaceOnUse'); // @see https://github.com/antvis/g/issues/1025

      $existed.setAttribute('x', '0%');
      $existed.setAttribute('y', '0%');
      $existed.setAttribute('width', '100%');
      $existed.setAttribute('height', '100%');
      $existed.id = filterId;
      $def.appendChild($existed);
    }
    /**
     * <rect id="wave-rect" x="0" y="0" width="100%" height="100%" fill="url(#wave)"></rect>
     * <filter id="blend-it" x="0%" y="0%" width="100%" height="100%">
          <feImage xlink:href="#wave-rect" result="myWave" x="100" y="100"/>
          <feImage xlink:href="#ry-rect" result="myRY"  x="100" y="100"/>
          <feBlend in="myWave" in2="myRY" mode="multiply" result="blendedGrad"/>
          <feComposite in="blendedGrad" in2="SourceGraphic" operator="in"/>
      </filter>
     */


    var blended = 0;
    gradients.forEach(function (gradient, i) {
      var gradientId = createOrUpdateGradient(document, object, $def, $el, gradient);
      var rectId = gradientId + '_rect';
      var $rect = createSVGElement('rect', document);
      $rect.setAttribute('x', '0');
      $rect.setAttribute('y', '0');
      $rect.setAttribute('width', '100%');
      $rect.setAttribute('height', '100%');
      $rect.setAttribute('fill', "url(#" + gradientId + ")");
      $rect.id = rectId;
      $def.appendChild($rect);
      var $feImage = createSVGElement('feImage', document);
      $feImage.setAttribute('href', "#" + rectId);
      $feImage.setAttribute('result', filterId + "-" + i);
      $existed.appendChild($feImage);

      if (i > 0) {
        var $feBlend = createSVGElement('feBlend', document);
        $feBlend.setAttribute('in', i === 1 ? filterId + "-" + (i - 1) : filterId + "-blended-" + (blended - 1));
        $feBlend.setAttribute('in2', filterId + "-" + i);
        $feBlend.setAttribute('result', filterId + "-blended-" + blended++); // @see https://developer.mozilla.org/zh-CN/docs/Web/CSS/blend-mode

        $feBlend.setAttribute('mode', 'multiply');
        $existed.appendChild($feBlend);
      }
    });
    var $feComposite = createSVGElement('feComposite', document);
    $feComposite.setAttribute('in', filterId + "-blended-" + blended);
    $feComposite.setAttribute('in2', 'SourceGraphic');
    $feComposite.setAttribute('operator', 'in');
    $existed.appendChild($feComposite);
    return filterId;
  }

  var FILTER_DROPSHADOW_PREFIX = 'g-filter-dropshadow-';
  /**
   * use SVG filters
   * @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Element/filter
   */

  function createOrUpdateShadow(document, $def, object, $el, name) {
    var _object$parsedStyle = object.parsedStyle,
        shadowType = _object$parsedStyle.shadowType,
        shadowBlur = _object$parsedStyle.shadowBlur,
        shadowColor = _object$parsedStyle.shadowColor,
        shadowOffsetX = _object$parsedStyle.shadowOffsetX,
        shadowOffsetY = _object$parsedStyle.shadowOffsetY;
    var hasShadow = !g.isNil(shadowColor) && shadowBlur > 0;
    var shadowId = FILTER_DROPSHADOW_PREFIX + object.entity;
    var $existedFilter = $def.querySelector("#" + shadowId);

    if ($existedFilter) {
      var existedShadowType = $existedFilter.getAttribute('data-type');

      if (existedShadowType !== shadowType || !hasShadow) {
        // remove existed shadow
        $existedFilter.remove();
        $existedFilter = null;
      }
    } // <Group> also has shadowType as its default value
    // only apply shadow when blur > 0


    if (hasShadow) {
      // use filter <feDropShadow>
      // @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/feDropShadow
      $el === null || $el === void 0 ? void 0 : $el.setAttribute('filter', "url(#" + shadowId + ")");
    } else {
      $el === null || $el === void 0 ? void 0 : $el.removeAttribute('filter');
      return;
    }

    if (!$existedFilter) {
      $existedFilter = createSVGElement('filter', document);
      $existedFilter.setAttribute('data-type', shadowType);

      if (shadowType === 'outer') {
        var $feDropShadow = createSVGElement('feDropShadow', document);
        $feDropShadow.setAttribute('dx', "" + (shadowOffsetX || 0) / 2);
        $feDropShadow.setAttribute('dy', "" + (shadowOffsetY || 0) / 2);
        $feDropShadow.setAttribute('stdDeviation', "" + (shadowBlur || 0) / 4);
        $feDropShadow.setAttribute('flood-color', shadowColor.toString());
        $existedFilter.appendChild($feDropShadow);
      } else if (shadowType === 'inner') {
        var $feComponentTransfer = createSVGElement('feComponentTransfer', document);
        $feComponentTransfer.setAttribute('in', 'SourceAlpha');
        var $feFuncA = createSVGElement('feFuncA', document);
        $feFuncA.setAttribute('type', 'table');
        $feFuncA.setAttribute('tableValues', '1 0');
        $feComponentTransfer.appendChild($feFuncA);
        $existedFilter.appendChild($feComponentTransfer);
        var $feGaussianBlur = createSVGElement('feGaussianBlur', document);
        $feGaussianBlur.setAttribute('stdDeviation', "" + (shadowBlur || 0) / 4);
        $existedFilter.appendChild($feGaussianBlur);
        var $feOffset = createSVGElement('feOffset', document);
        $feOffset.setAttribute('dx', "" + (shadowOffsetX || 0) / 2);
        $feOffset.setAttribute('dy', "" + (shadowOffsetY || 0) / 2);
        $feOffset.setAttribute('result', 'offsetblur');
        $existedFilter.appendChild($feOffset);
        var $feFlood = createSVGElement('feFlood', document);
        $feFlood.setAttribute('flood-color', shadowColor.toString());
        $feFlood.setAttribute('result', 'color');
        $existedFilter.appendChild($feFlood);
        var $feComposite = createSVGElement('feComposite', document);
        $feComposite.setAttribute('in2', 'offsetblur');
        $feComposite.setAttribute('operator', 'in');
        $existedFilter.appendChild($feComposite);
        var $feComposite2 = createSVGElement('feComposite', document);
        $feComposite2.setAttribute('in2', 'SourceAlpha');
        $feComposite2.setAttribute('operator', 'in');
        $existedFilter.appendChild($feComposite2);
        var $feMerge = createSVGElement('feMerge', document);
        $existedFilter.appendChild($feMerge);
        var $feMergeNode = createSVGElement('feMergeNode', document);
        $feMergeNode.setAttribute('in', 'SourceGraphic');
        var $feMergeNode2 = createSVGElement('feMergeNode', document);
        $feMerge.appendChild($feMergeNode);
        $feMerge.appendChild($feMergeNode2);
      }

      $existedFilter.id = shadowId; // @see https://github.com/antvis/g/issues/1025

      $existedFilter.setAttribute('filterUnits', 'userSpaceOnUse');
      $def.appendChild($existedFilter);
      return;
    }

    if (shadowType === 'inner') {
      var _$feGaussianBlur = $existedFilter.children[1];
      var _$feOffset = $existedFilter.children[2];
      var _$feFlood = $existedFilter.children[3];

      if (name === 'shadowColor') {
        _$feFlood.setAttribute('flood-color', shadowColor.toString());
      } else if (name === 'shadowBlur') {
        // half the blur radius
        // @see https://drafts.csswg.org/css-backgrounds/#shadow-blur
        // @see https://css-tricks.com/breaking-css-box-shadow-vs-drop-shadow/
        _$feGaussianBlur.setAttribute('stdDeviation', "" + (shadowBlur || 0) / 4);
      } else if (name === 'shadowOffsetX') {
        _$feOffset.setAttribute('dx', "" + (shadowOffsetX || 0) / 2);
      } else if (name === 'shadowOffsetY') {
        _$feOffset.setAttribute('dy', "" + (shadowOffsetY || 0) / 2);
      }
    } else if (shadowType === 'outer') {
      var _$feDropShadow = $existedFilter.children[0];

      if (name === 'shadowColor') {
        _$feDropShadow.setAttribute('flood-color', shadowColor.toString());
      } else if (name === 'shadowBlur') {
        // half the blur radius
        // @see https://drafts.csswg.org/css-backgrounds/#shadow-blur
        // @see https://css-tricks.com/breaking-css-box-shadow-vs-drop-shadow/
        _$feDropShadow.setAttribute('stdDeviation', "" + (shadowBlur || 0) / 4);
      } else if (name === 'shadowOffsetX') {
        _$feDropShadow.setAttribute('dx', "" + (shadowOffsetX || 0) / 2);
      } else if (name === 'shadowOffsetY') {
        _$feDropShadow.setAttribute('dy', "" + (shadowOffsetY || 0) / 2);
      }
    }
  }

  var urlRegexp = /url\(#(.*)\)/;

  var DefElementManager = /*#__PURE__*/function () {
    function DefElementManager() {
      this.canvasConfig = void 0;
      this.contextService = void 0;
      this.$def = void 0;
      this.gradientCache = {};
    }

    var _proto = DefElementManager.prototype;

    _proto.getDefElement = function getDefElement() {
      return this.$def;
    };

    _proto.init = function init() {
      var document = this.canvasConfig.document;
      var $svg = this.contextService.getContext();
      this.$def = createSVGElement('defs', document);
      $svg.appendChild(this.$def);
    };

    _proto.clear = function clear(entity) {
      var _this = this;

      Object.keys(this.gradientCache).forEach(function (id) {
        _this.clearUnusedDefElement(_this.gradientCache, id, entity);
      });
    };

    _proto.clearUnusedDefElement = function clearUnusedDefElement(cache, id, entity) {
      if (cache[id] && cache[id].size === 1 && cache[id].has(entity)) {
        var targetElement = this.$def.querySelector("#" + id);

        if (targetElement) {
          this.$def.removeChild(targetElement);
        }
      }
    };

    _proto.createOrUpdateGradientAndPattern = function createOrUpdateGradientAndPattern$1(object, $el, parsedColor, name) {
      var _this$canvasConfig = this.canvasConfig,
          doc = _this$canvasConfig.document,
          createImage = _this$canvasConfig.createImage;

      if ($el) {
        var _$el$getAttribute; // `url(#${gradientId})`


        var matches = (_$el$getAttribute = $el.getAttribute(name)) === null || _$el$getAttribute === void 0 ? void 0 : _$el$getAttribute.match(urlRegexp);

        if (matches && matches.length > 1) {
          this.clearUnusedDefElement(this.gradientCache, matches[1], object.entity);
        }

        var newDefElementId = createOrUpdateGradientAndPattern(doc || document, this.$def, object, $el, parsedColor, name, createImage);

        if (!this.gradientCache[newDefElementId]) {
          this.gradientCache[newDefElementId] = new Set();
        }

        this.gradientCache[newDefElementId].add(object.entity);
      }
    };

    _proto.createOrUpdateShadow = function createOrUpdateShadow$1(object, $el, name) {
      var doc = this.canvasConfig.document;
      createOrUpdateShadow(doc || document, this.$def, object, $el, name);
    };

    _proto.createOrUpdateFilter = function createOrUpdateFilter$1(object, $el, filters) {
      var doc = this.canvasConfig.document;
      createOrUpdateFilter(doc || document, this.$def, object, $el, filters);
    };

    return DefElementManager;
  }();

  __decorate([g.inject(g.CanvasConfig), __metadata("design:type", Object)], DefElementManager.prototype, "canvasConfig", void 0);

  __decorate([g.inject(g.ContextService), __metadata("design:type", Object)], DefElementManager.prototype, "contextService", void 0);

  DefElementManager = __decorate([g.singleton()], DefElementManager);

  var _class$1;

  var SVGRendererPlugin_1;
  var SVG_ATTR_MAP = {
    opacity: 'opacity',
    fillStyle: 'fill',
    fill: 'fill',
    fillOpacity: 'fill-opacity',
    strokeStyle: 'stroke',
    strokeOpacity: 'stroke-opacity',
    stroke: 'stroke',
    clipPath: 'clip-path',
    r: 'r',
    rx: 'rx',
    ry: 'ry',
    width: 'width',
    height: 'height',
    lineCap: 'stroke-linecap',
    lineJoin: 'stroke-linejoin',
    lineWidth: 'stroke-width',
    lineDash: 'stroke-dasharray',
    lineDashOffset: 'stroke-dashoffset',
    miterLimit: 'stroke-miterlimit',
    font: 'font',
    fontSize: 'font-size',
    fontStyle: 'font-style',
    fontVariant: 'font-variant',
    fontWeight: 'font-weight',
    fontFamily: 'font-family',
    letterSpacing: 'letter-spacing',
    startArrow: 'marker-start',
    endArrow: 'marker-end',
    class: 'class',
    id: 'id',
    // style: 'style',
    preserveAspectRatio: 'preserveAspectRatio',
    visibility: 'visibility',
    anchor: 'anchor',
    shadowColor: 'flood-color',
    shadowBlur: 'stdDeviation',
    shadowOffsetX: 'dx',
    shadowOffsetY: 'dy',
    filter: 'filter',
    innerHTML: 'innerHTML',
    textAlign: 'text-anchor',
    pointerEvents: 'pointer-events'
  };
  var FORMAT_VALUE_MAP = {
    textAlign: {
      inherit: 'inherit',
      left: 'left',
      start: 'left',
      center: 'middle',
      right: 'end',
      end: 'end'
    }
  };
  var DEFAULT_VALUE_MAP = {
    textAlign: 'inherit',
    // textBaseline: 'alphabetic',
    // @see https://www.w3.org/TR/SVG/painting.html#LineCaps
    lineCap: 'butt',
    // @see https://www.w3.org/TR/SVG/painting.html#LineJoin
    lineJoin: 'miter',
    // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Attribute/stroke-width
    lineWidth: '1px',
    opacity: '1',
    fillOpacity: '1',
    strokeOpacity: '1',
    strokeWidth: '0',
    strokeMiterLimit: '4',
    letterSpacing: '0',
    fontSize: 'inherit',
    fontFamily: 'inherit',
    pointerEvents: 'auto'
  };
  /**
   * G_SVG_PREFIX + nodeName + entity
   *
   * eg. g_svg_circle_345
   */

  var G_SVG_PREFIX = 'g_svg';
  var CLIP_PATH_PREFIX = 'clip-path-';
  var SVGRendererPlugin = SVGRendererPlugin_1 = (_class$1 = /*#__PURE__*/function () {
    function SVGRendererPlugin() {
      this.canvasConfig = void 0;
      this.camera = void 0;
      this.contextService = void 0;
      this.renderingContext = void 0;
      this.styleValueRegistry = void 0;
      this.createElementContribution = void 0;
      this.defElementManager = void 0;
      this.$camera = void 0;
      this.renderQueue = [];
      this.pendingReorderQueue = new Set();
    }

    var _proto = SVGRendererPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      var document = this.canvasConfig.document;

      var handleMounted = function handleMounted(e) {
        var object = e.target; // create SVG DOM Node

        _this.createSVGDom(document, object, _this.$camera);
      };

      var handleUnmounted = function handleUnmounted(e) {
        var object = e.target;

        _this.defElementManager.clear(object.entity);

        _this.removeSVGDom(object);
      };

      var handleAttributeChanged = function handleAttributeChanged(e) {
        var object = e.target; // @see https://github.com/antvis/g/issues/994
        // @ts-ignore

        if (!object.elementSVG) {
          return;
        }

        var attrName = e.attrName;

        if (attrName === 'zIndex') {
          var _object$parentNode, _object$parentNode$el;

          var parent = object.parentNode; // @ts-ignore

          var $groupEl = (_object$parentNode = object.parentNode) === null || _object$parentNode === void 0 ? void 0 : (_object$parentNode$el = _object$parentNode.elementSVG) === null || _object$parentNode$el === void 0 ? void 0 : _object$parentNode$el.$groupEl;
          var children = ((parent === null || parent === void 0 ? void 0 : parent.children) || []).slice();

          if ($groupEl) {
            _this.reorderChildren(document, $groupEl, children);
          }
        } else if (attrName === 'increasedLineWidthForHitTesting') {
          // @ts-ignore
          var svgElement = object.elementSVG;

          _this.createOrUpdateHitArea(object, svgElement.$el, svgElement.$groupEl);
        }

        _this.updateAttribute(object, [attrName]);
      };

      var handleGeometryBoundsChanged = function handleGeometryBoundsChanged(e) {
        var _object$elementSVG;

        var object = e.target; // @ts-ignore

        var $el = (_object$elementSVG = object.elementSVG) === null || _object$elementSVG === void 0 ? void 0 : _object$elementSVG.$el;
        var _object$parsedStyle = object.parsedStyle,
            fill = _object$parsedStyle.fill,
            stroke = _object$parsedStyle.stroke;

        if (fill && !(fill instanceof g.CSSRGB)) {
          _this.defElementManager.createOrUpdateGradientAndPattern(object, $el, fill, 'fill');
        }

        if (stroke && !(stroke instanceof g.CSSRGB)) {
          _this.defElementManager.createOrUpdateGradientAndPattern(object, $el, stroke, 'stroke');
        }
      };

      renderingService.hooks.init.tapPromise(SVGRendererPlugin_1.tag, /*#__PURE__*/_asyncToGenerator$2( /*#__PURE__*/_regeneratorRuntime$2().mark(function _callee() {
        var _this$canvasConfig, background, document, $svg;

        return _regeneratorRuntime$2().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$canvasConfig = _this.canvasConfig, background = _this$canvasConfig.background, document = _this$canvasConfig.document; // <defs>

                _this.defElementManager.init();

                $svg = _this.contextService.getContext();

                if (background) {
                  $svg.style.background = background;
                } // @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/color-interpolation-filters


                $svg.setAttribute('color-interpolation-filters', 'sRGB');
                _this.$camera = createSVGElement('g', document);
                _this.$camera.id = G_SVG_PREFIX + "_camera";

                _this.applyTransform(_this.$camera, _this.camera.getOrthoMatrix());

                $svg.appendChild(_this.$camera);

                _this.renderingContext.root.addEventListener(g.ElementEvent.MOUNTED, handleMounted);

                _this.renderingContext.root.addEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

                _this.renderingContext.root.addEventListener(g.ElementEvent.ATTR_MODIFIED, handleAttributeChanged);

                _this.renderingContext.root.addEventListener(g.ElementEvent.BOUNDS_CHANGED, handleGeometryBoundsChanged);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
      renderingService.hooks.destroy.tap(SVGRendererPlugin_1.tag, function () {
        _this.renderingContext.root.removeEventListener(g.ElementEvent.MOUNTED, handleMounted);

        _this.renderingContext.root.removeEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

        _this.renderingContext.root.removeEventListener(g.ElementEvent.ATTR_MODIFIED, handleAttributeChanged);

        _this.renderingContext.root.removeEventListener(g.ElementEvent.BOUNDS_CHANGED, handleGeometryBoundsChanged);
      });
      renderingService.hooks.render.tap(SVGRendererPlugin_1.tag, function (object) {
        // if (!object.isCulled()) {
        _this.renderQueue.push(object); // }

      });
      renderingService.hooks.beginFrame.tap(SVGRendererPlugin_1.tag, function () {
        var doc = _this.canvasConfig.document;

        if (_this.pendingReorderQueue.size) {
          _this.pendingReorderQueue.forEach(function (object) {
            var _object$elementSVG2;

            var children = ((object === null || object === void 0 ? void 0 : object.children) || []).slice();
            var $parentGroupEl = // @ts-ignore
            object === null || object === void 0 ? void 0 : (_object$elementSVG2 = object.elementSVG) === null || _object$elementSVG2 === void 0 ? void 0 : _object$elementSVG2.$groupEl;

            if ($parentGroupEl) {
              _this.reorderChildren(doc || document, $parentGroupEl, children || []);
            }
          });

          _this.pendingReorderQueue.clear();
        }
      });
      renderingService.hooks.endFrame.tap(SVGRendererPlugin_1.tag, function () {
        if (_this.renderingContext.renderReasons.has(g.RenderReason.CAMERA_CHANGED)) {
          _this.applyTransform(_this.$camera, _this.camera.getOrthoMatrix());
        }

        _this.renderQueue.forEach(function (object) {
          var _object$elementSVG3, _object$elementSVG4; // @ts-ignore


          var $el = (_object$elementSVG3 = object.elementSVG) === null || _object$elementSVG3 === void 0 ? void 0 : _object$elementSVG3.$el; // @ts-ignore

          var $groupEl = (_object$elementSVG4 = object.elementSVG) === null || _object$elementSVG4 === void 0 ? void 0 : _object$elementSVG4.$groupEl;

          if ($el && $groupEl) {
            // apply local RTS transformation to <group> wrapper
            // account for anchor
            _this.applyTransform($groupEl, object.getLocalTransform()); // finish rendering, clear dirty flag


            object.renderable.dirty = false;
          }
        });

        _this.renderQueue = [];
      });
    };

    _proto.reorderChildren = function reorderChildren(doc, $groupEl, children) {
      // need to reorder parent's children
      children.sort(function (a, b) {
        return a.sortable.renderOrder - b.sortable.renderOrder;
      });

      if (children.length) {
        // create empty fragment
        var fragment = (doc || document).createDocumentFragment();
        children.forEach(function (child) {
          if (child.isConnected) {
            // @ts-ignore
            var $el = child.elementSVG.$groupEl;

            if ($el) {
              fragment.appendChild($el);
            }
          }
        });
        $groupEl.appendChild(fragment);
      }
    };

    _proto.applyTransform = function applyTransform($el, rts) {
      // use proper precision avoiding too long string in `transform`
      // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations
      $el.setAttribute('transform', "matrix(" + numberToLongString(rts[0]) + "," + numberToLongString(rts[1]) + "," + numberToLongString(rts[4]) + "," + numberToLongString(rts[5]) + "," + numberToLongString(rts[12]) + "," + numberToLongString(rts[13]) + ")");
    };

    _proto.applyAttributes = function applyAttributes(object) {
      // @ts-ignore
      var elementSVG = object.elementSVG;
      var $el = elementSVG === null || elementSVG === void 0 ? void 0 : elementSVG.$el;
      var $groupEl = elementSVG === null || elementSVG === void 0 ? void 0 : elementSVG.$groupEl;

      if ($el && $groupEl) {
        var nodeName = object.nodeName,
            attributes = object.attributes;
        $el.setAttribute('fill', 'none');

        if (nodeName === g.Shape.IMAGE) {
          $el.setAttribute('preserveAspectRatio', 'none');
        } // apply attributes


        this.updateAttribute(object, Object.keys(attributes));
      }
    };

    _proto.updateAttribute = function updateAttribute(object, attributes) {
      var _this2 = this;

      var document = this.canvasConfig.document; // @ts-ignore

      var _object$elementSVG5 = object.elementSVG,
          $el = _object$elementSVG5.$el,
          $groupEl = _object$elementSVG5.$groupEl,
          $hitTestingEl = _object$elementSVG5.$hitTestingEl;
      var parsedStyle = object.parsedStyle,
          computedStyle = object.computedStyle;
      var shouldUpdateElementAttribute = attributes.some(function (name) {
        return _this2.createElementContribution.shouldUpdateElementAttribute(object, name);
      }); // need re-generate path

      if (shouldUpdateElementAttribute && $el) {
        [$el, $hitTestingEl].forEach(function ($el) {
          if ($el) {
            _this2.createElementContribution.updateElementAttribute(object, $el);

            if (object.nodeName !== g.Shape.TEXT) {
              _this2.updateAnchorWithTransform(object);
            }
          }
        });
      } // update common attributes


      attributes.forEach(function (name) {
        var _FORMAT_VALUE_MAP$nam, _cache$name;

        var usedName = SVG_ATTR_MAP[name];
        var computedValue = computedStyle[name];
        var computedValueStr = computedValue && computedValue.toString();
        var formattedValueStr = ((_FORMAT_VALUE_MAP$nam = FORMAT_VALUE_MAP[name]) === null || _FORMAT_VALUE_MAP$nam === void 0 ? void 0 : _FORMAT_VALUE_MAP$nam[computedValueStr]) || computedValueStr;
        var usedValue = parsedStyle[name];
        var inherited = !!((_cache$name = g.cache[name]) === null || _cache$name === void 0 ? void 0 : _cache$name.inherited);

        if (!usedName) {
          return;
        } // <foreignObject>


        if (object.nodeName === g.Shape.HTML) {
          if (name === 'lineWidth') {
            $el.style['border-width'] = (usedValue || 0) + "px";
          } else if (name === 'lineDash') {
            $el.style['border-style'] = 'dashed';
          }
        }

        if (name === 'fill') {
          if (object.nodeName === g.Shape.HTML) {
            $el.style.background = usedValue.toString();
          } else {
            _this2.defElementManager.createOrUpdateGradientAndPattern(object, $el, usedValue, usedName);
          }
        } else if (name === 'stroke') {
          if (object.nodeName === g.Shape.HTML) {
            $el.style['border-color'] = usedValue.toString();
            $el.style['border-style'] = 'solid';
          } else {
            _this2.defElementManager.createOrUpdateGradientAndPattern(object, $el, usedValue, usedName);
          }
        } else if (inherited && usedName) {
          // use computed value
          // update `visibility` on <group>
          if (computedValueStr !== 'unset' && computedValueStr !== DEFAULT_VALUE_MAP[name]) {
            $groupEl === null || $groupEl === void 0 ? void 0 : $groupEl.setAttribute(usedName, formattedValueStr);
          } else {
            $groupEl === null || $groupEl === void 0 ? void 0 : $groupEl.removeAttribute(usedName);
          }
        } else if (name === 'clipPath') {
          _this2.createOrUpdateClipPath(document, usedValue, $groupEl);
        } else if (name === 'shadowType' || name === 'shadowColor' || name === 'shadowBlur' || name === 'shadowOffsetX' || name === 'shadowOffsetY') {
          _this2.defElementManager.createOrUpdateShadow(object, $el, name);
        } else if (name === 'filter') {
          _this2.defElementManager.createOrUpdateFilter(object, $el, usedValue);
        } else if (name === 'innerHTML') {
          _this2.createOrUpdateInnerHTML(document, $el, usedValue);
        } else if (name === 'anchor') {
          // text' anchor is controlled by `textAnchor` property
          if (object.nodeName !== g.Shape.TEXT) {
            _this2.updateAnchorWithTransform(object);
          }
        } else {
          if (computedValue) {
            // use computed value so that we can use cascaded effect in SVG
            // ignore 'unset' and default value
            [$el, $hitTestingEl].forEach(function ($el) {
              if ($el && usedName) {
                if (computedValueStr !== 'unset' && computedValueStr !== DEFAULT_VALUE_MAP[name]) {
                  $el.setAttribute(usedName, formattedValueStr);
                } else {
                  $el.removeAttribute(usedName);
                }
              }
            });
          }
        }
      });
    };

    _proto.createSVGDom = function createSVGDom(document, object, root, noWrapWithGroup) {
      if (noWrapWithGroup === void 0) {
        noWrapWithGroup = false;
      } // create svg element
      // @ts-ignore


      object.elementSVG = new ElementSVG(); // @ts-ignore

      var svgElement = object.elementSVG; // use <group> as default, eg. CustomElement

      var $el = this.createElementContribution.createElement(object);

      if ($el) {
        var _object$parentNode$el2;

        var $groupEl; // save $el on parsedStyle, which will be returned in getDomElement()

        if (object.nodeName === g.Shape.HTML) {
          object.parsedStyle.$el = $el;
        }

        $el.id = G_SVG_PREFIX + "_" + object.nodeName + "_" + object.entity;

        if (($el.hasAttribute('data-wrapgroup') || $el.nodeName !== 'g') && !noWrapWithGroup) {
          $groupEl = createSVGElement('g', document);
          $groupEl.appendChild($el);
        } else {
          $groupEl = $el;
        }

        svgElement.$el = $el;
        svgElement.$groupEl = $groupEl; // apply attributes at first time

        this.applyAttributes(object); // create hitArea if necessary

        this.createOrUpdateHitArea(object, $el, $groupEl);
        var $parentGroupEl = // @ts-ignore
        object.parentNode && ((_object$parentNode$el2 = object.parentNode.elementSVG) === null || _object$parentNode$el2 === void 0 ? void 0 : _object$parentNode$el2.$groupEl) || root;

        if ($parentGroupEl) {
          $parentGroupEl.appendChild($groupEl); // need reorder children later

          this.pendingReorderQueue.add(object.parentNode);
        }
      }
    };

    _proto.removeSVGDom = function removeSVGDom(object) {
      var _object$elementSVG6; // @ts-ignore


      var $groupEl = (_object$elementSVG6 = object.elementSVG) === null || _object$elementSVG6 === void 0 ? void 0 : _object$elementSVG6.$groupEl;

      if ($groupEl && $groupEl.parentNode) {
        $groupEl.parentNode.removeChild($groupEl);
        this.createElementContribution.destroyElement(object, $groupEl); // object.entity.removeComponent(ElementSVG, true);
      }
    };

    _proto.createOrUpdateHitArea = function createOrUpdateHitArea(object, $el, $groupEl) {
      // @ts-ignore
      var svgElement = object.elementSVG;
      var $hitTestingEl = svgElement.$hitTestingEl;
      var increasedLineWidthForHitTesting = object.parsedStyle.increasedLineWidthForHitTesting; // account for hitArea

      if (increasedLineWidthForHitTesting) {
        if (!$hitTestingEl) {
          $hitTestingEl = $el.cloneNode(); // use the entity suffix, so that `g-plugin-svg-picker` can extract

          $hitTestingEl.id = G_SVG_PREFIX + "_" + object.nodeName + "_hittesting_" + object.entity; // clear attributes like `filter` `font-size`

          ['filter'].forEach(function (attribute) {
            $hitTestingEl.removeAttribute(attribute);
          }); // hitArea should be 'transparent' but not 'none'

          var hasFill = $el.getAttribute('fill') !== 'none';
          $hitTestingEl.setAttribute('fill', hasFill ? 'transparent' : 'none');
          $hitTestingEl.setAttribute('stroke', 'transparent');
          $groupEl.appendChild($hitTestingEl);
          svgElement.$hitTestingEl = $hitTestingEl;
        } // increase interactive line width


        $hitTestingEl.setAttribute('stroke-width', "" + (increasedLineWidthForHitTesting + object.parsedStyle.lineWidth));
      } else {
        if ($hitTestingEl) {
          $groupEl.removeChild($hitTestingEl);
          svgElement.$hitTestingEl = null;
        }
      }
    };

    _proto.createOrUpdateInnerHTML = function createOrUpdateInnerHTML(doc, $el, usedValue) {
      var $div = (doc || document).createElement('div');

      if (typeof usedValue === 'string') {
        $div.innerHTML = usedValue;
      } else {
        $div.appendChild(usedValue);
      }

      $el.innerHTML = '';
      $el.appendChild($div);
    };

    _proto.createOrUpdateClipPath = function createOrUpdateClipPath(document, clipPath, $groupEl) {
      if (clipPath) {
        var _clipPath$elementSVG;

        var clipPathId = CLIP_PATH_PREFIX + clipPath.entity;
        var $def = this.defElementManager.getDefElement();
        var existed = $def.querySelector("#" + clipPathId);

        if (!existed) {
          // create <clipPath> dom node, append it to <defs>
          var $clipPath = createSVGElement('clipPath', document);
          $clipPath.id = clipPathId;
          $def.appendChild($clipPath); // <clipPath><circle /></clipPath>

          this.createSVGDom(document, clipPath, $clipPath, true); // @ts-ignore

          clipPath.elementSVG.$groupEl = $clipPath;
        } // @ts-ignore


        var $clipPathGroupEl = (_clipPath$elementSVG = clipPath.elementSVG) === null || _clipPath$elementSVG === void 0 ? void 0 : _clipPath$elementSVG.$groupEl;

        if ($clipPathGroupEl) {
          // apply local RTS transformation to <group> wrapper
          this.applyTransform($clipPathGroupEl, clipPath.getLocalTransform());
        } // apply attributes


        this.applyAttributes(clipPath); // apply clipPath to $group
        // @see https://github.com/antvis/g/issues/961

        $groupEl.setAttribute('clip-path', "url(#" + clipPathId + ")");
      } else {
        // remove clip path
        $groupEl.removeAttribute('clip-path');
      }
    }
    /**
     * the origin is bounding box's top left corner
     */
    ;

    _proto.updateAnchorWithTransform = function updateAnchorWithTransform(object) {
      var _object$elementSVG7, _object$elementSVG8;

      var bounds = object.getGeometryBounds();
      var width = bounds && bounds.halfExtents[0] * 2 || 0;
      var height = bounds && bounds.halfExtents[1] * 2 || 0;

      var _ref2 = object.parsedStyle || {},
          anchor = _ref2.anchor; // @ts-ignore


      [(_object$elementSVG7 = object.elementSVG) === null || _object$elementSVG7 === void 0 ? void 0 : _object$elementSVG7.$el, (_object$elementSVG8 = object.elementSVG) === null || _object$elementSVG8 === void 0 ? void 0 : _object$elementSVG8.$hitTestingEl].forEach(function ($el) {
        if ($el) {
          var tx = -(anchor[0] * width);
          var ty = -(anchor[1] * height);

          if (tx !== 0 || ty !== 0) {
            // apply anchor to element's `transform` property
            $el.setAttribute('transform', // can't use percent unit like translate(-50%, -50%)
            // @see https://developer.mozilla.org/zh-CN/docs/Web/SVG/Attribute/transform#translate
            "translate(" + tx + "," + ty + ")");
          }

          if (object.nodeName === g.Shape.CIRCLE || object.nodeName === g.Shape.ELLIPSE) {
            $el.setAttribute('cx', "" + width / 2);
            $el.setAttribute('cy', "" + height / 2);
          }
        }
      });
    };

    return SVGRendererPlugin;
  }(), _class$1.tag = 'SVGRenderer', _class$1);

  __decorate([g.inject(g.CanvasConfig), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "canvasConfig", void 0);

  __decorate([g.inject(g.DefaultCamera), __metadata("design:type", g.Camera)], SVGRendererPlugin.prototype, "camera", void 0);

  __decorate([g.inject(g.ContextService), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "contextService", void 0);

  __decorate([g.inject(g.RenderingContext), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "renderingContext", void 0);

  __decorate([g.inject(g.StyleValueRegistry), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "styleValueRegistry", void 0);

  __decorate([g.inject(ElementLifeCycleContribution), __metadata("design:type", Object)], SVGRendererPlugin.prototype, "createElementContribution", void 0);

  __decorate([g.inject(DefElementManager), __metadata("design:type", DefElementManager)], SVGRendererPlugin.prototype, "defElementManager", void 0);

  SVGRendererPlugin = SVGRendererPlugin_1 = __decorate([g.singleton({
    contrib: g.RenderingPluginContribution
  })], SVGRendererPlugin);
  var containerModule$1 = g.Module(function (register) {
    register(DefElementManager);
    register(DefaultElementLifeCycleContribution);
    register(SVGRendererPlugin);
  });

  var Plugin$1 = /*#__PURE__*/function (_AbstractRendererPlug) {
    _inheritsLoose$2(Plugin, _AbstractRendererPlug);

    function Plugin() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _AbstractRendererPlug.call.apply(_AbstractRendererPlug, [this].concat(args)) || this;
      _this.name = 'svg-renderer';
      return _this;
    }

    var _proto = Plugin.prototype;

    _proto.init = function init() {
      this.container.load(containerModule$1, true);
    };

    _proto.destroy = function destroy() {
      this.container.unload(containerModule$1);
    };

    return Plugin;
  }(g.AbstractRendererPlugin);

  var index_esm$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    DEFAULT_VALUE_MAP: DEFAULT_VALUE_MAP,
    get DefaultElementLifeCycleContribution () { return DefaultElementLifeCycleContribution; },
    ElementLifeCycleContribution: ElementLifeCycleContribution,
    ElementSVG: ElementSVG,
    G_SVG_PREFIX: G_SVG_PREFIX,
    Plugin: Plugin$1,
    SHAPE2TAGS: SHAPE2TAGS,
    SHAPE_UPDATE_DEPS: SHAPE_UPDATE_DEPS,
    get SVGRendererPlugin () { return SVGRendererPlugin; },
    SVG_ATTR_MAP: SVG_ATTR_MAP,
    containerModule: containerModule$1,
    createSVGElement: createSVGElement,
    updateImageElementAttribute: updateImageElementAttribute,
    updateLineElementAttribute: updateLineElementAttribute,
    updatePathElementAttribute: updatePathElementAttribute,
    updatePolylineElementAttribute: updatePolylineElementAttribute,
    updateRectElementAttribute: updateRectElementAttribute,
    updateTextElementAttribute: updateTextElementAttribute
  });

  function _regeneratorRuntime$3() {
    /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
    _regeneratorRuntime$3 = function _regeneratorRuntime() {
      return exports;
    };

    var exports = {},
        Op = Object.prototype,
        hasOwn = Op.hasOwnProperty,
        $Symbol = "function" == typeof Symbol ? Symbol : {},
        iteratorSymbol = $Symbol.iterator || "@@iterator",
        asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
        toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }

    try {
      define({}, "");
    } catch (err) {
      define = function define(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
          generator = Object.create(protoGenerator.prototype),
          context = new Context(tryLocsList || []);
      return generator._invoke = function (innerFn, self, context) {
        var state = "suspendedStart";
        return function (method, arg) {
          if ("executing" === state) throw new Error("Generator is already running");

          if ("completed" === state) {
            if ("throw" === method) throw arg;
            return doneResult();
          }

          for (context.method = method, context.arg = arg;;) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
              if ("suspendedStart" === state) throw state = "completed", context.arg;
              context.dispatchException(context.arg);
            } else "return" === context.method && context.abrupt("return", context.arg);
            state = "executing";
            var record = tryCatch(innerFn, self, context);

            if ("normal" === record.type) {
              if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
              return {
                value: record.arg,
                done: context.done
              };
            }

            "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
          }
        };
      }(innerFn, self, context), generator;
    }

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    exports.wrap = wrap;
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
        NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if ("throw" !== record.type) {
          var result = record.arg,
              value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }

        reject(record.arg);
      }

      var previousPromise;

      this._invoke = function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (undefined === method) {
        if (context.delegate = null, "throw" === context.method) {
          if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
          context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            for (; ++i < iterable.length;) {
              if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            }

            return next.value = undefined, next.done = !0, next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }

    return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }

        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function reset(skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
          "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
        }
      },
      stop: function stop() {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function dispatchException(exception) {
        if (this.done) throw exception;
        var context = this;

        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
              record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
                hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function abrupt(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function complete(record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function finish(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function _catch(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }

  function asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator$3(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep$3(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _inheritsLoose$3(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;

    _setPrototypeOf$3(subClass, superClass);
  }

  function _setPrototypeOf$3(o, p) {
    _setPrototypeOf$3 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf$3(o, p);
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);

    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var _class$2;

  var SVGPickerPlugin_1;
  /**
   * pick shape(s) with Mouse/Touch event
   *
   * 1. find AABB with r-tree
   * 2. use elementFromPoint
   */

  var SVGPickerPlugin = SVGPickerPlugin_1 = (_class$2 = /*#__PURE__*/function () {
    function SVGPickerPlugin() {
      this.canvasConfig = void 0;
      this.displayObjectPool = void 0;
    }

    var _proto = SVGPickerPlugin.prototype;

    _proto.apply = function apply(renderingService) {
      var _this = this;

      var doc = this.canvasConfig.document;
      renderingService.hooks.pick.tapPromise(SVGPickerPlugin_1.tag, /*#__PURE__*/function () {
        var _ref = _asyncToGenerator$3( /*#__PURE__*/_regeneratorRuntime$3().mark(function _callee(result) {
          var topmost, _result$position, clientX, clientY, targets, _iterator, _step, element, id, index, target;

          return _regeneratorRuntime$3().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  topmost = result.topmost, _result$position = result.position, clientX = _result$position.clientX, clientY = _result$position.clientY;
                  _context.prev = 1;
                  targets = []; // @see https://developer.mozilla.org/zh-CN/docs/Web/API/Document/elementsFromPoint

                  _iterator = _createForOfIteratorHelperLoose((doc || document).elementsFromPoint(clientX, clientY));

                case 4:
                  if ((_step = _iterator()).done) {
                    _context.next = 17;
                    break;
                  }

                  element = _step.value; // eg. g_svg_circle_345

                  id = element && element.getAttribute('id');

                  if (!(id && id.startsWith(G_SVG_PREFIX))) {
                    _context.next = 15;
                    break;
                  }

                  index = id.lastIndexOf('_');
                  target = _this.displayObjectPool.getByEntity(Number(id.substring(index + 1))); // don't need to account for `visibility` since DOM API already does

                  if (!(target && target.isInteractive())) {
                    _context.next = 15;
                    break;
                  }

                  targets.push(target);

                  if (!topmost) {
                    _context.next = 15;
                    break;
                  }

                  result.picked = targets;
                  return _context.abrupt("return", result);

                case 15:
                  _context.next = 4;
                  break;

                case 17:
                  result.picked = targets;
                  _context.next = 23;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t0 = _context["catch"](1);
                  result.picked = [];

                case 23:
                  return _context.abrupt("return", result);

                case 24:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[1, 20]]);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    };

    return SVGPickerPlugin;
  }(), _class$2.tag = 'SVGPicker', _class$2);

  __decorate([g.inject(g.CanvasConfig), __metadata("design:type", Object)], SVGPickerPlugin.prototype, "canvasConfig", void 0);

  __decorate([g.inject(g.DisplayObjectPool), __metadata("design:type", g.DisplayObjectPool)], SVGPickerPlugin.prototype, "displayObjectPool", void 0);

  SVGPickerPlugin = SVGPickerPlugin_1 = __decorate([g.singleton({
    contrib: g.RenderingPluginContribution
  })], SVGPickerPlugin);
  var containerModule$2 = g.Module(function (register) {
    register(SVGPickerPlugin);
  });

  var Plugin$2 = /*#__PURE__*/function (_AbstractRendererPlug) {
    _inheritsLoose$3(Plugin, _AbstractRendererPlug);

    function Plugin() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _AbstractRendererPlug.call.apply(_AbstractRendererPlug, [this].concat(args)) || this;
      _this.name = 'svg-picker';
      return _this;
    }

    var _proto = Plugin.prototype;

    _proto.init = function init() {
      this.container.load(containerModule$2, true);
    };

    _proto.destroy = function destroy() {
      this.container.unload(containerModule$2);
    };

    return Plugin;
  }(g.AbstractRendererPlugin);

  var index_esm$2 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Plugin: Plugin$2
  });

  var SVGContextService = /*#__PURE__*/function () {
    function SVGContextService() {
      this.$container = void 0;
      this.$namespace = void 0;
      this.dpr = void 0;
      this.canvasConfig = void 0;
    }

    var _proto = SVGContextService.prototype;

    _proto.init = /*#__PURE__*/function () {
      var _init = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var _this$canvasConfig, container, doc, $namespace, dpr;

        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$canvasConfig = this.canvasConfig, container = _this$canvasConfig.container, doc = _this$canvasConfig.document; // create container

                this.$container = g.isString(container) ? (doc || document).getElementById(container) : container;

                if (this.$container) {
                  if (!this.$container.style.position) {
                    this.$container.style.position = 'relative';
                  }

                  $namespace = createSVGElement('svg', doc);
                  $namespace.setAttribute('width', "" + this.canvasConfig.width);
                  $namespace.setAttribute('height', "" + this.canvasConfig.height);
                  this.$container.appendChild($namespace);
                  this.$namespace = $namespace;
                }

                dpr = window.devicePixelRatio || 1;
                dpr = dpr >= 1 ? Math.ceil(dpr) : 1;
                this.dpr = dpr;

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }() // @ts-ignore
    ;

    _proto.getDomElement = function getDomElement() {
      return this.$namespace;
    };

    _proto.getContext = function getContext() {
      return this.$namespace;
    };

    _proto.getDPR = function getDPR() {
      return this.dpr;
    };

    _proto.getBoundingClientRect = function getBoundingClientRect() {
      var _this$$namespace;

      return (_this$$namespace = this.$namespace) === null || _this$$namespace === void 0 ? void 0 : _this$$namespace.getBoundingClientRect();
    };

    _proto.destroy = function destroy() {
      // destroy context
      if (this.$container && this.$namespace && this.$namespace.parentNode) {
        this.$container.removeChild(this.$namespace);
      }
    };

    _proto.resize = function resize(width, height) {
      if (this.$namespace) {
        this.$namespace.setAttribute('width', "" + width);
        this.$namespace.setAttribute('height', "" + height);
      }
    };

    _proto.applyCursorStyle = function applyCursorStyle(cursor) {
      if (this.$container) {
        this.$container.style.cursor = cursor;
      }
    };

    _proto.toDataURL = /*#__PURE__*/function () {
      var _toDataURL = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(options) {
        var cloneNode, svgDocType, svgDoc;
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:

                cloneNode = this.$namespace.cloneNode(true);
                svgDocType = document.implementation.createDocumentType('svg', '-//W3C//DTD SVG 1.1//EN', 'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd');
                svgDoc = document.implementation.createDocument('http://www.w3.org/2000/svg', 'svg', svgDocType);
                svgDoc.replaceChild(cloneNode, svgDoc.documentElement);
                return _context2.abrupt("return", "data:image/svg+xml;charset=utf8," + encodeURIComponent(new XMLSerializer().serializeToString(svgDoc)));

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function toDataURL(_x) {
        return _toDataURL.apply(this, arguments);
      }

      return toDataURL;
    }();

    return SVGContextService;
  }();

  __decorate([g.inject(g.CanvasConfig), __metadata("design:type", Object)], SVGContextService.prototype, "canvasConfig", void 0);

  SVGContextService = __decorate([g.singleton({
    token: g.ContextService
  })], SVGContextService);

  var containerModule$3 = g.Module(function (register) {
    /**
     * implements ContextService
     */
    register(SVGContextService);
  });
  var ContextRegisterPlugin = /*#__PURE__*/function (_AbstractRendererPlug) {
    _inheritsLoose(ContextRegisterPlugin, _AbstractRendererPlug);

    function ContextRegisterPlugin() {
      var _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _AbstractRendererPlug.call.apply(_AbstractRendererPlug, [this].concat(args)) || this;
      _this.name = 'svg-context-register';
      return _this;
    }

    var _proto = ContextRegisterPlugin.prototype;

    _proto.init = function init() {
      this.container.load(containerModule$3, true);
    };

    _proto.destroy = function destroy() {
      this.container.unload(containerModule$3);
    };

    return ContextRegisterPlugin;
  }(g.AbstractRendererPlugin);

  var Renderer = /*#__PURE__*/function (_AbstractRenderer) {
    _inheritsLoose(Renderer, _AbstractRenderer);

    function Renderer(config) {
      var _this;

      _this = _AbstractRenderer.call(this, config) || this;

      _this.registerPlugin(new ContextRegisterPlugin());

      _this.registerPlugin(new Plugin$1());

      _this.registerPlugin(new Plugin());

      _this.registerPlugin(new Plugin$2());

      return _this;
    }

    return Renderer;
  }(g.AbstractRenderer);

  exports.DomInteraction = index_esm;
  exports.Renderer = Renderer;
  exports.SVGPicker = index_esm$2;
  exports.SVGRenderer = index_esm$1;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
